﻿<%@ Page Title="" Language="C#" MasterPageFile="~/WebsiteMasterPage.master" AutoEventWireup="true" CodeFile="admin_BXH.aspx.cs" Inherits="admin_module_admin_BXH" %>

<asp:Content ID="Content1" ContentPlaceHolderID="headlink" runat="Server">
    <link href="/admin_css/datatables.css" rel="stylesheet" />
    <style>
        #tableView_wrapper .dt-buttons {
            display: none;
        }
    </style>
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="hihead" runat="Server">
</asp:Content>
<asp:Content ID="Content3" ContentPlaceHolderID="himenu" runat="Server">
</asp:Content>
<asp:Content ID="Content4" ContentPlaceHolderID="higlobal" runat="Server">
</asp:Content>
<asp:Content ID="Content5" ContentPlaceHolderID="hislider" runat="Server">
</asp:Content>
<asp:Content ID="Content6" ContentPlaceHolderID="hibelowtop" runat="Server">
</asp:Content>
<asp:Content ID="Content7" ContentPlaceHolderID="hibodyhead" runat="Server">
</asp:Content>
<asp:Content ID="Content8" ContentPlaceHolderID="hibodywrapper" runat="Server">

    <div class="content">
        <div class="animated fadeIn">
            <div class="row">
                <div class="col-lg-12">
                    <div class="card">
                        <div class="card-header d-flex justify-content-between align-items-center">
                            <div>
                                <strong class="mr-2 ">Bảng xếp hạng</strong>
                            </div>

                        </div>
                        <%-- <div class="card-body">
                            <h4 class="box-title">Bảng xếp hạng</h4>
                        </div>--%>

                        <div class="card-body">
                            <table id="tableAll" class="table table-striped table-bordered" style="width: 100%">
                                <thead>
                                    <tr>
                                        <th>ID</th>
                                        <th>Tên cuộc thi</th>
                                        <th>Số người</th>
                                        <th>Tình trạng</th>
                                        <th>#</th>
                                    </tr>
                                </thead>
                                <tbody>
                                </tbody>
                                <tfoot>
                                    <tr>
                                        <th>ID</th>
                                        <th>Tên cuộc thi</th>
                                        <th></th>
                                        <th>Tình trạng</th>
                                        <th></th>
                                    </tr>
                                </tfoot>
                            </table>
                        </div>

                    </div>
                </div>
            </div>

        </div>
    </div>
    <!-- Modal - Calendar --->
    <div class="modal fade none-border" id="ModalView">
        <div class="modal-dialog modal-xl">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                    <h5 class="modal-title"><strong class="mr-3">Bảng xếp hạng</strong>
                        <button type="button" class="btn btn-sm btn-outline-info" onclick="btnExport('excel',this.id)" id="btnExportExcel" data-idtable="tableView"><i class="fa fa-file-excel-o"></i>&nbsp;Excel</button></h5>
                </div>
                <div class="modal-body">
                    <table id="tableView" class="table table-striped table-bordered" style="width: 100%">
                        <thead>
                            <tr>
                                <th>Thứ hạng</th>
                                <th>Tên trong app</th>
                                <th>Tên đi học</th>
                                <th>Khối lớp</th>
                                <th>Trường</th>
                                <th>Tài khoản</th>
                                <th>ID bé</th>
                                <th>Điểm</th>
                                <th>Thời gian làm bài</th>
                                <th>Thời gian cập nhật</th>
                                <th>Phường/Xã</th>
                                <th>Quận/Huyện</th>
                                <th>Thành phố</th>
                                <th>Số điện thoại</th>
                                <th>Địa chỉ nhận thưởng</th>
                                <th>#</th>
                            </tr>
                        </thead>
                        <tbody>
                        </tbody>
                    </table>
                </div>

            </div>
        </div>
    </div>
</asp:Content>
<asp:Content ID="Content9" ContentPlaceHolderID="hibodybottom" runat="Server">
</asp:Content>
<asp:Content ID="Content10" ContentPlaceHolderID="hibelowbottom" runat="Server">
</asp:Content>
<asp:Content ID="Content11" ContentPlaceHolderID="hifooter" runat="Server">
    <script src="/admin_js/datatables.min.js"></script>

    <script type="text/javascript">
        let _nameEventExport = "";
        function btnExport(type, id) {
            let idtable = jQuery('#' + id).data('idtable');
            if (type == 'print') {
                jQuery('#' + idtable + '_wrapper .buttons-print').click();
            }
            else if (type == 'excel') {
                jQuery('#' + idtable + '_wrapper .buttons-excel').click();
            } else if (type == 'pdf') {

            }
        }
        jQuery(document).ready(function ($) {
            $('input.form-check-input[type="radio"]').on('click', function (e) {
                $('.form-check-label').removeClass('active');
                $(this).parents('.form-check-label').toggleClass('active');
                var idshow = $(this).attr('data-ref');
                $('#tab-main .tab-pane').removeClass('active show');
                $('#' + idshow).addClass('active show');
            });


            moment.locale('vi');
            jQuery('input[name="datetimes"]').daterangepicker({
                singleDatePicker: true,
                timePicker: true,
                timePicker24Hour: true,
                autoApply: true,
                startDate: moment(),
                locale: {
                    format: 'DD/MM/YYYY H:mm'
                }
            });
            jQuery('input[name="datetimes"]').on('apply.daterangepicker', function (ev, picker) {
                $(this).val(picker.startDate.format('DD/MM/YYYY H:mm'));
            });

            jQuery('input[name="dates"]').daterangepicker({
                singleDatePicker: true,
                autoApply: true,
                startDate: moment(),
                locale: {
                    format: 'DD/MM/YYYY'
                }
            });
            jQuery('input[name="dates"]').on('apply.daterangepicker', function (ev, picker) {
                $(this).val(picker.startDate.format('DD/MM/YYYY'));
            });

            //if (rolesinfologin !== "admin") {
            //    swal("Cảnh báo", "Không có quyền truy cập.", "warning",
            //        {
            //            buttons: true,
            //        }).then(function (value) {
            //            if (value == true) {
            //                window.location.href = "/";
            //            }
            //        });
            //}
            //else {
            loadtable();
            //}
        });

        function loadtable() {
            jQuery(document).ready(function ($) {
                var url = _apiLink + "/leaderboards";
                jQuery('#tableAll').DataTable({
                    "processing": true,
                    "pageLength": 50,
                    "language": {
                        "url": "/admin_js/datatables-vn.json"
                    },
                    ajax: {
                        url: url,
                        headers: { 'Authorization': 'Bearer ' + tokenlogin },
                        dataSrc: 'data', error: function (xhr, status, error) { errShow(xhr); }
                    },

                    initComplete: function () {
                        this.api().columns([1, 4]).every(function () {
                            var column = this;
                            var select = $('<select><option value="">Tất cả</option></select>')
                                .appendTo($(column.footer()).empty())
                                .on('change', function () {
                                    var val = $.fn.dataTable.util.escapeRegex(
                                        $(this).val()
                                    );
                                    column
                                        .search(val ? '^' + val + '$' : '', true, false)
                                        .draw();
                                });

                            column.data().unique().sort().each(function (d, j) {
                                select.append('<option value="' + d + '">' + d + '</option>')
                            });
                        });
                    },
                    "columns": [
                        {
                            "data": function (row, profile, set) {
                                if (row.code != null) {
                                    return row.code;
                                }
                            },
                            "defaultContent": "N/A"
                        },
                        {
                            "data": function (row, profile, set) {
                                var html = "";
                                if (row.event != null) {
                                    html += row.event.name;
                                    html += " <br />";
                                    var timeStart = new Date(row.time_start);
                                    var timeEnd = new Date(row.time_end);

                                    var ngaytimeStart = AddZero(timeStart.getDate()) + "/" + AddZero(timeStart.getMonth() + 1) + "/" + timeStart.getFullYear();
                                    var ngaytimeEnd = AddZero(timeEnd.getDate()) + "/" + AddZero(timeEnd.getMonth() + 1) + "/" + timeEnd.getFullYear();
                                    html += " <code>" + ngaytimeStart + " - " + ngaytimeEnd + "</code>";
                                    return html;
                                }
                            },
                            "defaultContent": "N/A"
                        },
                        {
                            "data": function (row, profile, set) {
                                if (row.count != null) {
                                    return row.count;
                                }
                            },
                            "defaultContent": "N/A"
                        },
                        {
                            "data": function (row, profile, set) {
                                if (row.status != null) {
                                    return row.status;
                                }
                            },
                            "defaultContent": "N/A"
                        },
                        {
                            "data": function (row, profile, set) {
                                var html = "";
                                if (row != null) {
                                    var _nameEvent = "";
                                    if (row.event != null && row.event != void 0)
                                        _nameEvent = row.event.name;
                                    html += "<div class='d-flex'>";
                                    html += "<a class='btn btn-hdong btn-edit' href='javascript:void(0)' id='btnXemBC" + row._id + "' onclick='fucviewrow(this.id)' data-id='" + row._id + "' data-event='" + _nameEvent + "' data-toggle='modal' data-target='#ModalView' title='Xem thông tin'><i class='fa fa-eye'></i></a>";
                                    html += "<a class='btn btn-hdong btn-delete' href='javascript:void(0)' id='" + row._id + "' onclick='fucdeleterow(this.id)' title='Xóa thông tin'><i class='fa fa-close'></i></a>";
                                    html += "</div>";
                                    return html;
                                }
                            },
                            "defaultContent": ""
                        }
                    ]
                });
            });
        }

        function fucviewrow(_btnId) {
            _nameEventExport = jQuery('#' + _btnId).attr('data-event');
            var _id = jQuery('#' + _btnId).attr('data-id');
            var table = jQuery('#tableView').DataTable();
            table.clear().draw();
            table.destroy();
            jQuery(document).ready(function ($) {
                var url = _apiLink + "/leaderboards/" + _id + "/top?includes=username&includes=address";
                jQuery('#tableView').DataTable({
                    "processing": true,
                    "pageLength": 50,
                    "language": {
                        "url": "/admin_js/datatables-vn.json"
                    },
                    dom: 'Bfrtip',
                    buttons: [
                        {
                            title: 'Kết quả cuộc thi - ' + _nameEventExport,
                            extend: 'excel',
                            exportOptions: {
                                columns: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14]
                            }
                        },

                    ],

                    "columnDefs": [
                        {
                            "targets": [2, 3, 4, 10, 11, 12, 13, 14],
                            "visible": false,
                            "searchable": false
                        },
                        { width: '20px', targets: 0 },
                        { width: '20px', targets: 13 },
                        { className: "text-center", targets: [0, 7, 8, 9] }
                    ],

                    ajax: {
                        url: url,
                        headers: { 'Authorization': 'Bearer ' + tokenlogin },
                        dataSrc: 'data', error: function (xhr, status, error) { errShow(xhr); }
                    },
                    initComplete: function () {
                        this.api().columns([1, 4]).every(function () {
                            var column = this;
                            var select = $('<select><option value="">Tất cả</option></select>')
                                .appendTo($(column.footer()).empty())
                                .on('change', function () {
                                    var val = $.fn.dataTable.util.escapeRegex(
                                        $(this).val()
                                    );
                                    column
                                        .search(val ? '^' + val + '$' : '', true, false)
                                        .draw();
                                });

                            column.data().unique().sort().each(function (d, j) {
                                select.append('<option value="' + d + '">' + d + '</option>')
                            });
                        });
                    },


                    "columns": [
                        {
                            "data": function (row, profile, set) {
                                if (row.stt != null) {
                                    var top = row.stt + 1;
                                    return top;
                                }
                            },
                            "defaultContent": "N/A"
                        },
                        {
                            "data": function (row, profile, set) {
                                if (row.child != void 0 && row.child != null) {
                                    if (row.child.nameInApp != void 0 && row.child.nameInApp != null)
                                        return row.child.nameInApp;
                                }
                            },
                            "defaultContent": "N/A"
                        },
                        {
                            "data": function (row, profile, set) {
                                if (row.child != void 0 && row.child != null) {
                                    if (row.child.name != void 0 && row.child.name != null)
                                        return row.child.name;
                                }
                            },
                            "defaultContent": "N/A"
                        },
                        {
                            "data": function (row, profile, set) {
                                if (row.classAge != null && row.classAge != void 0 && row.classAge.length > 0) {
                                    var _len = row.classAge.length - 1;
                                    return row.classAge[_len].name;
                                }
                            },
                            "defaultContent": "N/A"
                        },
                        {
                            "data": function (row, profile, set) {
                                if (row.child != void 0 && row.child != null) {
                                    if (row.child.schoolName != void 0 && row.child.schoolName != null)
                                        return row.child.schoolName;
                                }
                            },
                            "defaultContent": "N/A"
                        },

                        {
                            "data": function (row, profile, set) {
                                if (row.user_id != void 0) {
                                    return row.user_id?.user;
                                }
                            },
                            "defaultContent": "N/A"
                        },
                        {
                            "data": function (row, profile, set) {
                                if (row.childCode != null) {
                                    return row.childCode;
                                }
                            },
                            "defaultContent": "N/A"
                        },
                        {
                            "data": function (row, profile, set) {
                                if (row.score != null) {
                                    return row.score;
                                }
                            },
                            "defaultContent": "N/A"
                        },
                        {
                            "data": function (row, profile, set) {
                                if (row.duration != null) {
                                    return row.duration.toFixed(4);
                                }
                            },
                            "defaultContent": "N/A"
                        },
                        {
                            "data": function (row, profile, set) {
                                if (row.star != null) {
                                    var updatedAt = new Date(row.updatedAt);
                                    return getdatenow(updatedAt);
                                }
                            },
                            "defaultContent": "N/A"
                        },
                        {
                            "data": function (row, profile, set) {
                                if (row.province != void 0 && row.province != null && row.province.length > 0) {
                                    if (row.province[0].ward != void 0 && row.province[0].ward != null)
                                        return row.province[0].ward.name;
                                }
                            },
                            "defaultContent": "Phường/Xã"
                        },
                        {
                            "data": function (row, profile, set) {
                                if (row.province != void 0 && row.province != null && row.province.length > 0) {
                                    if (row.province[0].district != void 0 && row.province[0].district != null)
                                        return row.province[0].district.name;

                                }
                            },
                            "defaultContent": "Quận/Huyện"
                        },
                        {
                            "data": function (row, profile, set) {
                                if (row.province != void 0 && row.province != null && row.province.length > 0)
                                    return row.province[0].name;
                            },
                            "defaultContent": "Tỉnh/thành phố"
                        },
                        {
                            "data": function (row, profile, set) {
                                if (row.phone != null && row.phone != void 0) {
                                    return row.phone;
                                }
                            },
                            "defaultContent": "N/A"
                        },
                        {
                            "data": function (row, profile, set) {
                                if (row.address != null && row.address != void 0) {
                                    return row.address;
                                }
                            },
                            "defaultContent": "N/A"
                        },
                        {
                            "data": function (row, profile, set) {
                                var html = "";
                                if (row != null) {

                                    html += "<div class='d-flex'>";
                                    html += "<button type='button' class='btn btn-hdong btn-delete' id='" + row._id + "' title='" + _id + "' onclick='fucdeleterowUser(this.title, this.id)' title='Xóa thông tin'><i class='fa fa-close'></i></button>";
                                    html += "</div>";
                                    return html;
                                }
                            },
                            "defaultContent": ""
                        }

                    ]
                });
            });


        }

        function fucdeleterowUser(_idlb, _iditem) {
            var idinfologin = localStorage.getItem("idinfologin");
            swal("Bạn thực sự muốn xóa", "Nếu xóa dữ liệu sẽ không thể phục hồi", "warning",
                {
                    buttons: true,
                    dangerMode: true
                }).then(function (value) {
                    if (value == true) {
                        var url = _apiLink + "/leaderboards/" + _idlb + "/" + _iditem;
                        jQuery.ajax({
                            type: "DELETE",
                            url: url,
                            headers: { 'Authorization': 'Bearer ' + tokenlogin },
                            contentType: "application/json; charset=utf-8",
                            data: '',
                            dataType: "json",
                            success: function (data) {
                                var tableView = jQuery('#tableView').DataTable();
                                tableView.ajax.reload();
                                var table = jQuery('#tableAll').DataTable();
                                table.ajax.reload();
                                swal("Thành công", "Xóa dữ liệu thành công", "success");
                            },
                            error: function (xhr, status, error) {
                                errShow(xhr);
                            }
                        });
                    }
                });
        }

        function fucdeleterow(_id) {
            var idinfologin = localStorage.getItem("idinfologin");
            swal("Bạn thực sự muốn xóa", "Nếu xóa dữ liệu sẽ không thể phục hồi", "warning",
                {
                    buttons: true,
                    dangerMode: true
                }).then(function (value) {
                    if (value == true) {
                        var url = _apiLink + "/leaderboards/" + _id;
                        jQuery.ajax({
                            type: "DELETE",
                            url: url,
                            headers: { 'Authorization': 'Bearer ' + tokenlogin },
                            contentType: "application/json; charset=utf-8",
                            data: '',
                            dataType: "json",
                            success: function (data) {
                                var table = jQuery('#tableAll').DataTable();
                                table.ajax.reload();
                                swal("Thành công", "Xóa dữ liệu thành công", "success");
                            },
                            error: function (xhr, status, error) {
                                errShow(xhr);
                            }
                        });
                    }
                });
        }

        function AddZero(num) {
            return (num >= 0 && num < 10) ? "0" + num : num + "";
        }

        function getdatenow(now) {
            //var now = new Date();
            var strDateTime = [[AddZero(now.getDate()),
            AddZero(now.getMonth() + 1),
            now.getFullYear()].join("-"),
            [AddZero(now.getUTCHours()),
            AddZero(now.getUTCMinutes())].join(":"),
            now.getUTCHours() >= 12 ? "PM" : "AM"].join(" ");
            return strDateTime;
        };
    </script>
</asp:Content>

